# subgraph-opt
fast optimization for subgraph problems

This repo contains the code for ICML 2017 paper *Connected subgraph detection with mirror descent on SDPs*. It aims to solve a subgraph detection optimization problem, namely Eq. (11) in the paper.

- Main functions for solving the optimization is under starOpt, specifically `staropt/staropt_fast.m` for the optimized version for large scale problems (Algorithm 1)
- Scripts for experiments on the large scale geometric graphs are under `geo-code/geo_exps.m,` where you can see how above code is called
- Other scripts, mostly for solving the disease outbreak detection are under aistats-code folder, such as the `county_auc_fast.m` script
- geogen folder contains the graph generator program that our collaborator Lorenzo provided, used to generate inputs for the random geometric graph experiments
- expleja is a library dependency for starOpt available at https://bitbucket.org/expleja/expleja
